<?php

namespace Netzmacher\QuickShop\TCA\Ctrl;

use Netzmacher\QuickShop\Utility\Userfunc\TYPO3v;

if( !defined( 'TYPO3_MODE' ) )
{
	die( 'Access denied.' );
}

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2017-2019 -  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * @author      Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package     TYPO3
 * @subpackage  quick_shop
 * @version     9.2.0
 * @since       7.0.2
 */
class Icons
{

	public static $pathDefault = 'EXT:quick_shop/ext_icon';
	public static $pathInquiryform = 'EXT:quick_shop/Resources/Public/Images/Icons/ExtIcon/inquiryform';
	public static $pathNotype = 'EXT:quick_shop/Resources/Public/Images/Icons/ExtIcon/notype';
	public static $pathPage = 'EXT:quick_shop/Resources/Public/Images/Icons/ExtIcon/page';
	public static $pathProduct = 'EXT:quick_shop/Resources/Public/Images/Icons/ExtIcon/product';
	public static $pathRecord = 'EXT:quick_shop/Resources/Public/Images/Icons/ExtIcon/record';
	public static $pathUrl = 'EXT:quick_shop/Resources/Public/Images/Icons/ExtIcon/url';

	/**
	 * Register Icons
	 *
	 * @return      void
	 * @version     7.0.2
	 * @since       7.0.2
	 */
	static public function RegisterIcons( $ext = 'svg' )
	{
		if( TYPO3v::get() < 7006000 )
		{
			return;
		}

		$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( \TYPO3\CMS\Core\Imaging\IconRegistry::class );

		foreach( SELF::_getClassWiIcons( $ext ) as $class => $source )
		{
			$iconRegistry->registerIcon(
							$class
							, \TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class
							, [ 'source' => $source ]
			);
		}
	}

	/**
	 * Get icon array from TYPO3 7.6
	 *
	 * @access public
	 * @return      array
	 * @version     8.10.0
	 * @since       7.0.2
	 */
	static public function TypeIconClasses()
	{
		switch( TRUE )
		{
			case( TYPO3v::get() < 7006000 ):
				return NULL;
			case( TYPO3v::get() >= 7006000 ):
			default:
				return array(
						'default' => 'ext-quickshop-products',
						'inquiryform' => 'ext-quickshop-inquiryform',
						'notype' => 'ext-quickshop-notype',
						'page' => 'ext-quickshop-page',
						'product' => 'ext-quickshop-product',
						'record' => 'ext-quickshop-record',
						'url' => 'ext-quickshop-url',
				);
		}
	}

	/**
	 * Get icon array with classes and paths
	 *
	 * @return      void
	 * @version     9.2.0
	 * @since       7.0.2
	 */
	static private function _getClassWiIcons( $ext = 'svg' )
	{
		return array(
				'ext-quickshop-inquiryform' => SELF::$pathInquiryform . '.' . $ext,
				'ext-quickshop-products' => SELF::$pathDefault . '.' . $ext,
				'ext-quickshop-notype' => SELF::$pathNotype . '.' . $ext,
				'ext-quickshop-page' => SELF::$pathPage . '.' . $ext,
				'ext-quickshop-product' => SELF::$pathProduct . '.' . $ext,
				'ext-quickshop-record' => SELF::$pathRecord . '.' . $ext,
				'ext-quickshop-url' => SELF::$pathUrl . '.' . $ext,
		);
	}

}
