<?php

namespace Netzmacher\QuickShop\Utility\ExtensionManager;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class provides methods for the extension manager.
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage    org
 * @version 8.10.0
 * @since 0.3.1
 */
class Simplifyer
{

	/**
	 * getPidConfigration(): 
	 *
	 * @return  string    
	 * @access public
	 * @version 8.10.0
	 * @since 0.3.1
	 */
	static public function getPidConfigration()
	{
		$confArr = SELF::getConfArray();
		switch( $confArr[ 'simplifyer.' ][ 'store_records' ] )
		{
			case('Current folder'):
			case('Easy 1: all in the same directory'): // organiser < v3.x
				return 'pid=###CURRENT_PID###';
			case('Managed by general record storage page'):
			case('Easy 2: same as 1 but with storage pid'): // organiser < v3.x
			case('Folder with a storage pid'): // organiser < v8.0.27
				return 'pid=###STORAGE_PID###';
			case('Managed by page TSconfig (ID)'):
			case('Clear presented: each record group in one directory at most'): // organiser < v3.x
			case('Folder group'): // organiser < v8.0.27
				return 'pid IN (###PAGE_TSCONFIG_ID###)';
			case('Managed by page TSconfig (list)'):
			case('Multi grouped: record groups in different directories'): // organiser < v3.x
			case('Folder multigroup'): // organiser < v8.0.27
				return 'pid IN (###PAGE_TSCONFIG_IDLIST###)';
			case('Everywhere'):
			case('Everywhere (recommended)'): // organiser < v8.0.27
			default:
				return 'uid > 0';
		}
	}

	/**
	 * getPidConfigration(): 
	 *
	 * @return  string    
	 * @access static
	 * @version 8.10.0
	 * @since 0.3.1
	 */
	static private function getConfArray()
	{
		return unserialize( $GLOBALS[ 'TYPO3_CONF_VARS' ][ 'EXT' ][ 'extConf' ][ 'quick_shop' ] );
	}

}
