<?php

namespace Netzmacher\QuickShop\Utility\Update;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2017-2019 -  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 *
 * @author  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package TYPO3
 * @subpackage quick_shop
 * @version     8.13.4
 * @since       7.0.1
 */
class ScriptFAL
{

	private $currUidSysFile = 0;
	private $currUidSysFileMetadata = 0;
	private $currUidSysFileReference = 0;
	private $devDry = FALSE; // for development only. Live modus: FALSE
	private $FALmapping = array();
	private $ll = 'LLL:EXT:quick_shop/Resources/Private/Language/Update/scriptFAL.xml:';
	private $uploadFolder = 'uploads/tx_quickshop/';

//  /**
//   * Checks how many rows are found and returns true if there are any
//   * (this function is called from the extension manager)
//   *
//   * @param	string		$what: what should be updated
//   * @return	boolean
//   */
//  public function access( $what = 'all' )
//  {
//    return TRUE;
//  }

	private function actionFAL()
	{
		$tables = array();
		foreach( array_keys( $GLOBALS[ 'TCA' ] ) as $table )
		{
			if( substr( $table, 0, strlen( 'tx_quickshop_' ) ) != 'tx_quickshop_' )
			{
				continue;
			}
			foreach( $GLOBALS[ 'TCA' ][ $table ][ 'columns' ] as $colname => $col )
			{
				switch( TRUE )
				{
//          case(!isset( $col[ 'config' ][ 'appearance' ] )):
//            continue 2;
					case($col[ 'config' ][ 'foreign_table' ] != 'sys_file_reference' ):
//var_dump( __METHOD__, __LINE__, $table, $colname );
						continue 2;
					case(!isset( $col[ 'config' ][ 'type' ] )):
//var_dump( __METHOD__, __LINE__, $table, $colname );
						continue 2;
					case($col[ 'config' ][ 'type' ] != 'inline'):
//var_dump( __METHOD__, __LINE__, $table, $colname );
						continue 2;
				}
				$tables[ $table ][] = $colname;
			}
		}
//var_dump( __METHOD__, __LINE__, $tables );
		return $tables;
	}

	private function actionFALEmpty()
	{
		$confArr = unserialize( $GLOBALS[ 'TYPO3_CONF_VARS' ][ 'EXT' ][ 'extConf' ][ 'quick_shop' ] );
		$falDisabled = $confArr[ 'fal.' ][ 'disabled' ];

		switch( $falDisabled )
		{
			case(TRUE):
				return $this->prompt( 'promptNoFAL', 'information' );
			case(FALSE):
			default:
				return $this->prompt( 'promptFALIsDone', 'ok' );
		}
	}

	private function actionFALList( $tables )
	{
		$input = NULL;

		foreach( $tables as $table => $fields )
		{
			$prompt = '';
			$values = array();

			foreach( $fields as $field )
			{
				$prompt = ''
								. $prompt
								. $this->actionFALListPrompt( $table, $field )
				;

				$values[] = $table . '.' . $field;
			}

			if( empty( $prompt ) )
			{
				continue;
			}

			$value = implode( ',', $values );

			$input = ''
							. $input
							. '<input id="' . $table . '" type="checkbox" name="tables[]" value="' . $value . '" />' . PHP_EOL
							. '<label for="' . $table . '">' . $table . '</label>' . PHP_EOL
							. '<br />' . PHP_EOL
							. $prompt
							. '<br />' . PHP_EOL
			;
		}

		switch( TRUE )
		{
			case(empty( $input )):
				$input = ''
								. $this->prompt( 'promptFALIsDone', 'ok' )
								. '<br />' . PHP_EOL
				;
				break;
			case(!empty( $input )):
			default:
				$input = ''
								. $this->prompt( 'promptBackupDb', 'information' )
								. $this->prompt( 'promptFALNoSupportPath', 'notice' )
								. $input
								. '<br />' . PHP_EOL
				;
				break;
		}

		return $input;
	}

	private function actionFALListPrompt( $table, $field )
	{
		if( !$field )
		{
			return NULL;
		}

		$rows = $this->actionFALListSqlRows( $table, $field );

		if( empty( $rows ) )
		{
			return NULL;
		}

		switch( $rows )
		{
			case(1):
				$strRecords = 'one record ';
				break;
			default:
				$strRecords = $rows . ' records ';
				break;
		}

		$prompt = ''
						. $table . '.' . $field . ' contains ' . $strRecords . 'for converting.'
						. '<br />' . PHP_EOL
		;

		return $prompt;
	}

	private function actionFALListSqlResultSet( $table, $field )
	{

		$sql = $GLOBALS[ 'TYPO3_DB' ]->SELECTquery(
						'uid, ' . $field, $table, $field . ' <> \'\''
		);
		$resultSet = $GLOBALS[ 'TYPO3_DB' ]->sql_query( $sql );
		return $resultSet;
	}

	private function actionFALListSqlRows( $table, $field )
	{
		$rowsCount = 0;

		$resultSet = $this->actionFALListSqlResultSet( $table, $field );
		if( empty( $resultSet ) )
		{
			$GLOBALS[ 'TYPO3_DB' ]->sql_free_result( $resultSet );
			return NULL;
		}

		while( ($row = $GLOBALS[ 'TYPO3_DB' ]->sql_fetch_assoc( $resultSet ) ) )
		{
			//var_dump( __METHOD__, __LINE__, $table, $row, $row[ $field ] );
			switch( TRUE )
			{
				case( empty( $row[ $field ] )):
					continue 2
					;
				case( ( string ) ( int ) $row[ $field ] == ( string ) $row[ $field ]):
					continue 2
					;
				default:
					// follow the workflow
					break;
			}

			$rowsCount = $rowsCount + 1;
		}
		$GLOBALS[ 'TYPO3_DB' ]->sql_free_result( $resultSet );

		//var_dump( __METHOD__, __LINE__, $table, $rowsCount );
		return $rowsCount;
	}

	private function actionFALUpdate()
	{

		// #i0263, 181025, dwildt, 1-/2+
		//$tables = array_map( trim, ( array ) \TYPO3\CMS\Core\Utility\GeneralUtility::_GP( 'tables' ) );
		$tables = array_map( $callback, ( array ) \TYPO3\CMS\Core\Utility\GeneralUtility::_GP( 'tables' ) );
		unset( $callback );

		switch( TRUE )
		{
			case(empty( $tables )):
				return ''
								. '<legend>' . $GLOBALS[ 'LANG' ]->sL( $this->ll . 'formFALHeader' ) . '</legend>'
								. $this->prompt( 'promptNoTableSelected', 'information' )
								. $this->form( NULL, NULL, 'formReloadButton' )
				;
			default:
				return ''
								. $this->actionFALUpdateTablefields( $tables )
				;
		}
	}

	private function actionFALUpdateConvert( $tablefield )
	{
		$this->initFALMapping();

		$rows = ( array ) $this->actionFALUpdateConvertSelect( $tablefield );
		//var_dump( __METHOD__, __LINE__, $rows );
		foreach( $rows as $row )
		{
			$this->actionFALUpdateConvertSql( $tablefield, $row );
		}

		return TRUE;
	}

	private function actionFALUpdateConvertSelect( $tablefield )
	{
		list($table, $field) = explode( '.', $tablefield );

		$select = '*';
		//$where = $this->sqlSelectWhereFAL( $field );
		$where = $field . ' <> \'\'';
		$groupBy = NULL;
		$orderBy = NULL;
		$limit = NULL;

		$res = $GLOBALS[ 'TYPO3_DB' ]->exec_SELECTquery( $select, $table, $where, $groupBy, $orderBy, $limit );
		$this->sqlSelectErrorPrompt( $select, $table, $where, $groupBy, $orderBy, $limit );

		while( $row = $GLOBALS[ 'TYPO3_DB' ]->sql_fetch_assoc( $res ) )
		{
			switch( TRUE )
			{
				case( empty( $row[ $field ] )):
					continue 2
					;
				case( ( string ) ( int ) $row[ $field ] == ( string ) $row[ $field ]):
					continue 2
					;
				default:
					// follow the workflow
					break;
			}
			$rows[] = $row;
		}

		return $rows;
	}

	private function actionFALUpdateConvertSql( $tablefield, $row )
	{
		list($table, $field) = explode( '.', $tablefield );
		unset( $table );
		$files = explode( ',', $row[ $field ] );

		$path = \TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName( $this->uploadFolder );
		$path = rtrim( $path, '/' ) . '/';

		$files_exist = array();
		$filePosition = -1;
		foreach( $files as $file )
		{
			$filePosition = $filePosition + 1;
			$pathToFile = $path . $file;
			if( !file_exists( $pathToFile ) )
			{
				continue;
			}
			$files_exist[] = $file;
			$this->sqlInsertSysFile( $row, $file );
			$this->sqlInsertSysFileMetadata( $tablefield, $row, $file, $filePosition );
			$this->sqlInsertSysFileReference( $tablefield, $row, $filePosition );
		}
		$this->sqlUpdateTxOrg( $tablefield, $row, $files_exist );

		return TRUE;
	}

	private function actionFALUpdateTablefields( $tablefields )
	{
		$errorTablefields = array();
		$successTablefields = array();

		foreach( $tablefields as $csvTablefields )
		{
			$arrTablefields = explode( ',', $csvTablefields );
			foreach( $arrTablefields as $tablefield )
			{
				if( $this->actionFALUpdateConvert( $tablefield ) )
				{
					$successTablefields[] = $tablefield;
				}
				else
				{
					$errorTablefields[] = $tablefield;
				}
			}
		}

		$content = ''
						. '<ul>'
						. '<li>'
						. implode( ', </li>' . PHP_EOL . '<li>', $successTablefields )
						. '</li>'
						. '</ul>'
		;

		if( $this->devDry )
		{
			var_dump( __METHOD__, __LINE__ );
//      die();
		}

		return ''
						. $this->prompt( 'promptUpdateFAL', 'ok' )
						. $this->form( 'formFALSuccessHeader', $content, 'formReloadButton' )
		;
	}

	private function actionUpdate()
	{
		switch( TRUE )
		{
			case( \TYPO3\CMS\Core\Utility\GeneralUtility::_GP( 'action' ) == 'updateFAL'):
				$content = $this->actionFALUpdate();
				break;
			default:
				$content = '<a href="' . \TYPO3\CMS\Core\Utility\GeneralUtility::linkThisScript( array( 'do_update' => '', 'func' => '' ) ) . '">'
								. $GLOBALS[ 'LANG' ]->sL( $this->ll . 'back' )
								. '</a>'
								. '<br>';
		}

		return $content;
	}

	private function form( $legend, $content, $button, $action = NULL )
	{
		if( $legend )
		{
			$legend = '<legend>' . $GLOBALS[ 'LANG' ]->sL( $this->ll . $legend ) . '</legend>';
		}
		return '
      <form action="" method="POST">
        ' . $legend . '
        <fieldset>
          ' . $this->formInput( $action ) . '
          ' . $content . '
          ' . $this->formButton( $button ) . '
        </fieldset>
			</form>
      <p>&nbsp;</p>
      '
		;
	}

	private function formButton( $button )
	{
		return ''
						. '<input type="submit" class="button" value="' . $GLOBALS[ 'LANG' ]->sL( $this->ll . $button ) . '">' . PHP_EOL
		;
	}

	private function formInput( $action = NULL )
	{
		$moduleToken = \TYPO3\CMS\Core\Utility\GeneralUtility::_GP( 'moduleToken' );

		if( $action )
		{
			$action = '<input type="hidden" name="action" value="' . $action . '" />' . PHP_EOL;
		}

		return ''
						. '<input type="hidden" name="moduleToken" value="' . $moduleToken . '" />' . PHP_EOL
						. '<input type="hidden" name="M" value="tools_ExtensionmanagerExtensionmanager" />' . PHP_EOL
						. '<input type="hidden" name="tx_extensionmanager_tools_extensionmanagerextensionmanager[extensionKey]" value="quick_shop" />' . PHP_EOL
						. '<input type="hidden" name="tx_extensionmanager_tools_extensionmanagerextensionmanager[action]" value="show" />' . PHP_EOL
						. '<input type="hidden" name="tx_extensionmanager_tools_extensionmanagerextensionmanager[controller]" value="UpdateScript" />' . PHP_EOL
						. $action
		;
	}

	private function initFALMapping()
	{
		$this->FALmapping = array(
				'documents' => array(
						'sys_file_metadata' => array(
								'description' => 'documentscaption',
						),
				),
				'image' => array(
						'sys_file_metadata' => array(
								'alternative' => 'imageseo',
								'description' => 'imagecaption',
								'title' => 'imageseo',
						),
				),
				'thumbnail' => array(
				),
		);
	}

	/**
	 * Main function, returning the HTML content of the update script
	 *
	 * @return	string		HTML
	 * @version     7.0.1
	 * @since       7.0.1
	 */
	public function main()
	{
		$action = \TYPO3\CMS\Core\Utility\GeneralUtility::_GP( 'action' );

		switch( TRUE )
		{
			case( $action == 'updateFAL'):
				return $this->actionUpdate();
			case(!empty( $action )):
				return NULL;
			default:
				return $this->menu();
		}
	}

	/**
	 * Returns the menu
	 *
	 * @return	string		The menu
	 * @version     7.0.1
	 * @since       7.0.0
	 */
	private function menu()
	{
		$FAL = $this->actionFAL();
//    var_dump( __METHOD__, __LINE__, $FAL );
//    die();

		switch( TRUE )
		{
			case(empty( $FAL )):
				return $this->form( 'formFALHeader', $this->actionFALEmpty(), 'formReloadButton' );
			case(!empty( $FAL )):
			default:
				return $this->form( 'formFALHeader', $this->actionFALList( $FAL ), 'formFALButton', 'updateFAL' );
		}
	}

	private function prompt( $prompt, $severity = 'information' )
	{
		// #i0262, 181025, dwildt, 4+
		$alertSeverity = $severity;
		switch( TRUE )
		{
			case( $alertSeverity == "information" ):
				$alertSeverity = "info";
				break;
			case( $alertSeverity == "ok" ):
				$alertSeverity = "success";
				break;
		}

		// #i0262, 181025, dwildt, ~
		return '
			<div class="alert alert-' . $alertSeverity . ' typo3-message message-' . $severity . '">
        <div class="message-header">' . $GLOBALS[ 'LANG' ]->sL( $this->ll . $prompt . 'Header' ) . '</div>
        <div class="message-body">
          ' . $GLOBALS[ 'LANG' ]->sL( $this->ll . $prompt . 'Prompt' ) . '
        </div>
      </div>' . PHP_EOL;
	}

	private function sqlInsertErrorPrompt( $table, $fields )
	{
		$error = $GLOBALS[ 'TYPO3_DB' ]->sql_error();
		if( empty( $error ) )
		{
			return;
		}

		$query = $GLOBALS[ 'TYPO3_DB' ]->INSERTquery( $table, $fields );
		$prompt = '<h1>Quick Shop: SQL-Error</h1>'
						. '<p>' . $error . '</p>'
						. '<p>' . $query . '</p>';
		die( $prompt );
	}

	private function sqlInsertSysFile( $row, $file )
	{
		list($name, $ext) = explode( '.', $file );
		unset( $name );

		$fields = array(
				'creation_date' => $row[ 'crdate' ]
				, 'extension' => $ext
				, 'identifier' => '/' . $this->uploadFolder . $file
				, 'modification_date' => $row[ 'tstamp' ]
				, 'name' => $file
				, 'tstamp' => time()
		);

		if( $this->devDry )
		{
			var_dump( __METHOD__, __LINE__, $GLOBALS[ 'TYPO3_DB' ]->INSERTquery( 'sys_file', $fields ) );
			return;
		}

		$GLOBALS[ 'TYPO3_DB' ]->exec_INSERTquery( 'sys_file', $fields );
		$this->sqlInsertErrorPrompt( 'sys_file', $fields );
		$this->currUidSysFile = $GLOBALS[ 'TYPO3_DB' ]->sql_insert_id();

		return;
	}

	private function sqlInsertSysFileMetadata( $tablefield, $row, $file, $filePosition )
	{
		list($table, $field) = explode( '.', $tablefield );
		unset( $table );

		$graphicalFunctionsObject = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( \TYPO3\CMS\Core\Imaging\GraphicalFunctions::class );
		$graphicalFunctionsObject->init();
		$info = $graphicalFunctionsObject->getImageDimensions( PATH_site . $this->uploadFolder . $file );

		$fields = array(
				'crdate' => $row[ 'crdate' ]
				, 'cruser_id' => $row[ 'cruser_id' ]
				, 'file' => $this->currUidSysFile
				, 'height' => $info[ 1 ]
				, 'tstamp' => time()
				, 'width' => $info[ 0 ]
		);

		$mappingItems = ( array ) $this->FALmapping[ $field ][ 'sys_file_metadata' ];
		foreach( $mappingItems as $destField => $srceField )
		{
			$srceFields = preg_split( '/\R/', $row[ $srceField ] );
			$fields[ $destField ] = $srceFields[ $filePosition ];
		}

		if( $this->devDry )
		{
			var_dump( __METHOD__, __LINE__, $GLOBALS[ 'TYPO3_DB' ]->INSERTquery( 'sys_file_metadata', $fields ) );
			return;
		}

		$GLOBALS[ 'TYPO3_DB' ]->exec_INSERTquery( 'sys_file_metadata', $fields );
		$this->sqlInsertErrorPrompt( 'sys_file_metadata', $fields );
		$this->currUidSysFileMetadata = $GLOBALS[ 'TYPO3_DB' ]->sql_insert_id();

		return;
	}

	private function sqlInsertSysFileReference( $tablefield, $row, $filePosition )
	{
		list($table, $field) = explode( '.', $tablefield );

		$fields = array(
				'crdate' => $row[ 'crdate' ]
				, 'cruser_id' => $row[ 'cruser_id' ]
				, 'fieldname' => $field
				, 'pid' => $row[ 'pid' ]
				, 'sorting_foreign' => 256 * ($filePosition + 1)
				, 'tablenames' => $table
				, 'table_local' => 'sys_file'
				, 'uid_local' => $this->currUidSysFile
				, 'uid_foreign' => $row[ 'uid' ]
				, 'tstamp' => time()
		);

		$mappingItems = ( array ) $this->FALmapping[ $field ][ 'sys_file_reference' ];
		foreach( $mappingItems as $destField => $srceField )
		{
			$srceFields = preg_split( '/\R/', $row[ $srceField ] );
			$fields[ $destField ] = $srceFields[ $filePosition ];
		}

		if( $this->devDry )
		{
			var_dump( __METHOD__, __LINE__, $GLOBALS[ 'TYPO3_DB' ]->INSERTquery( 'sys_file_reference', $fields ) );
			return;
		}

		$GLOBALS[ 'TYPO3_DB' ]->exec_INSERTquery( 'sys_file_reference', $fields );
		$this->sqlInsertErrorPrompt( 'sys_file_reference', $fields );
		$this->currUidSysFileReference = $GLOBALS[ 'TYPO3_DB' ]->sql_insert_id();

		return;
	}

	private function sqlUpdateErrorPrompt( $table, $where, $fields )
	{
		$error = $GLOBALS[ 'TYPO3_DB' ]->sql_error();
		if( empty( $error ) )
		{
			return;
		}

		$query = $GLOBALS[ 'TYPO3_DB' ]->UPDATEquery( $table, $where, $fields );
		$prompt = '<h1>Quick Shop: SQL-Error</h1>'
						. '<p>' . $error . '</p>'
						. '<p>' . $query . '</p>';
		die( $prompt );
		;
	}

	private function sqlUpdateTxOrg( $tablefield, $row, $files )
	{
		list($table, $field) = explode( '.', $tablefield );

		$fields = array(
				$field => count( $files )
				, 'tstamp' => time()
		);

		$where = 'uid=' . $row[ 'uid' ];

		if( $this->devDry )
		{
			var_dump( __METHOD__, __LINE__, $GLOBALS[ 'TYPO3_DB' ]->INSERTquery( 'sys_file_reference', $fields ) );
			return;
		}

		$GLOBALS[ 'TYPO3_DB' ]->exec_UPDATEquery( $table, $where, $fields );
		$this->sqlUpdateErrorPrompt( $table, $where, $fields );

		return;
	}

	private function sqlSelectErrorPrompt( $select, $table, $where, $groupBy, $orderBy, $limit )
	{
		$error = $GLOBALS[ 'TYPO3_DB' ]->sql_error();

		if( !$error )
		{
			return;
		}

		$query = $GLOBALS[ 'TYPO3_DB' ]->SELECTquery( $select, $table, $where, $groupBy, $orderBy, $limit );
		$prompt = '<h1>Quick Shop: SQL-Error</h1>' . PHP_EOL
						. '<p>' . $error . '</p>' . PHP_EOL
						. '<p>' . $query . '</p>' . PHP_EOL
						. '<p>' . PHP_EOL
						. 'Please take care for a proper configuration at plugin.tx_caddy_pi1.db<br />' . PHP_EOL
						. 'Sorry for the trouble.<br />' . PHP_EOL
						. 'TYPO3 Caddy<br />' . PHP_EOL
						. __METHOD__ . ' (' . __LINE__ . ')'
		;
		die( $prompt );
	}

	private function sqlSelectWhereFAL( $field )
	{
		return ''
						. $field . ' <> \'\' '
						. 'AND CAST(' . $field . ' AS DECIMAL) <> ' . $field
		//. 'AND CAST(CAST(' . $field . ' AS DECIMAL) AS CHAR) <> ' . $field
		//. 'AND CONVERT(CONVERT(image, DECIMAL), CHAR) <> ' . $field
		;
	}

}
