<?php

if( !defined( 'TYPO3_MODE' ) )
{
	die( 'Access denied.' );
}

$_EXTKEY = 'quick_shop';
$fal = \Netzmacher\QuickShop\ExtensionManager::getFal();
$imageMode = 'small'; // small || medium || big

$TCA = array(
		'ctrl' => array(
				'title' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop_material.xml:tx_quickshop_material',
				'label' => 'title',
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'default_sortby' => 'ORDER BY title',
				'delete' => 'deleted',
				'dividers2tabs' => true, // 180318, dwildt: deprecated, but needed for TYPO3 6.2
				'enablecolumns' => array(
						'disabled' => 'hidden',
				),
				// 180318, dwildt, BUG: Is needed for selectTree, but isn't displayed, if 'typeicon_classes'  is set.
				'iconfile' => 'EXT:quick_shop/ext_icon.gif', // 180318, dwildt: And is needed for TYP03 6.2
				'thumbnail' => 'image',
				'type' => 'type',
				'typeicon_column' => 'type',
				'typeicon_classes' => \Netzmacher\QuickShop\TCA\Ctrl\Icons::TypeIconClasses(),
				'searchFields' => ''
				. 'description,'
				. '%%%description_lang_ol,%%%'
				. 'hidden,'
				. 'page,'
				. 'short,'
				. '%%%short_lang_ol,%%%'
				. 'title,'
				. '%%%title_lang_ol,%%%'
				. 'tx_quickshop_products,'
				. 'type,'
				. 'uid_parent,'
				. 'url,'
		),
		'interface' => array(
				'showRecordFieldList' => ''
				. 'description,'
				. '%%%description_lang_ol,%%%'
				. 'hidden,'
				. 'page,'
				. 'short,'
				. '%%%short_lang_ol,%%%'
				. 'title,'
				. '%%%title_lang_ol,%%%'
				. 'tx_quickshop_products,'
				. 'type,'
				. 'uid_parent,'
				. 'url,'
		),
		'columns' => array(
				'description' => array(
						'exclude' => 0,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.description',
						'config' => array(
								'type' => 'text',
								'cols' => '30',
								'rows' => '5',
								'eval' => 'trim',
								'fieldControl' => array(
										'fullScreenRichtext' => array(
												'disabled' => '',
										),
								),
								'enableRichtext' => true,
						),
				),
				'description_lang_ol' => array(
						'exclude' => 1,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.translation',
						'config' => \Netzmacher\QuickShop\TCA\Columns\Config::RTE(),
				),
				'hidden' => \Netzmacher\QuickShop\TCA\Columns::Hidden(),
				'page' => array(
						'exclude' => 0,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.page',
						'config' => array(
								'type' => 'group',
								'internal_type' => 'db',
								'allowed' => 'pages',
								'size' => '1',
								'maxitems' => '1',
								'minitems' => '1',
						),
				),
				'short' => array(
						'exclude' => 0,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.short',
						'config' => array(
								'type' => 'input',
								'size' => '30',
						)
				),
				'short_lang_ol' => array(
						'exclude' => 1,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.translation',
						'config' => array(
								'type' => 'input',
								'size' => '30',
						),
				),
				'title' => array(
						'exclude' => 0,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop_material.xml:tx_quickshop_material.title',
						'config' => array(
								'type' => 'input',
								'size' => '30',
								'eval' => 'required',
						)
				),
				'title_lang_ol' => array(
						'exclude' => 1,
						'label' => 'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.translation',
						'config' => array(
								'type' => 'input',
								'size' => '30',
						),
				),
				'tx_quickshop_products' => \Netzmacher\QuickShop\TCA\Columns::SelectMultipleSideBySide( 'tx_quickshop_products', 'tx_quickshop_material', NULL, 'tx_quickshop_products' ),
				'type' => \Netzmacher\QuickShop\TCA\Columns::Type(),
				'uid_parent' => \Netzmacher\QuickShop\TCA\Columns::UidParent(
								'LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:label.superiorcategory'
								, 'tx_quickshop_material'
								, 'AND tx_quickshop_material.pid=###CURRENT_PID### '
								. 'ORDER BY tx_quickshop_material.title'
				),
				'url' => \Netzmacher\QuickShop\TCA\Columns::URL(),
		),
		'palettes' => array(
				'title' => array(
						'showitem' => ''
						. 'title,%%%title_lang_ol,%%%%%%--linebreak--,%%%'
						. 'short,%%%short_lang_ol,%%%'
						,
						'canNotCollapse' => 1,
				),
				'typepage' => \Netzmacher\QuickShop\TCA\Palettes::TypePage(),
				'typeurl' => \Netzmacher\QuickShop\TCA\Palettes::TypeUrl(),
		),
		'types' => array(
				'0' => array(
						'showitem' => ''
						. '  type,'
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.title;title,'
						. 'description' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ','
						. '%%%description_lang_ol' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ',%%%'
						. 'uid_parent,'
						. \Netzmacher\QuickShop\TCA\Types::Image( $imageMode, $fal ) . ','
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.product,'
						. '  tx_quickshop_products,'
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.control,'
						. '  hidden,'
				),
				'notype' => array(
						'showitem' => ''
						. '  type,'
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.title;title,'
						. 'description' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ','
						. '%%%description_lang_ol' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ',%%%'
						. 'uid_parent,'
						. \Netzmacher\QuickShop\TCA\Types::Image( $imageMode, $fal ) . ','
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.product,'
						. '  tx_quickshop_products,'
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.control,'
						. '  hidden,'
				),
				'page' => array(
						'showitem' => ''
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.typepage;typepage,'
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.title;title,'
						. 'description' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ','
						. '%%%description_lang_ol' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ',%%%'
						. 'uid_parent,'
						. \Netzmacher\QuickShop\TCA\Types::Image( $imageMode, $fal ) . ','
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.product,'
						. '  tx_quickshop_products,'
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.control,'
						. '  hidden,'
				),
				'record' => array(
						'showitem' => ''
						. '  type,'
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.title;title,'
						. 'description' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ','
						. '%%%description_lang_ol' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ',%%%'
						. 'uid_parent,'
						. \Netzmacher\QuickShop\TCA\Types::Image( $imageMode, $fal ) . ','
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.product,'
						. '  tx_quickshop_products,'
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.control,'
						. '  hidden,'
				),
				'url' => array(
						'showitem' => ''
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.typeurl;typeurl,'
						. '  --palette--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:palette.title;title,'
						. 'description' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ','
						. '%%%description_lang_ol' . \Netzmacher\QuickShop\TCA\Palettes::RTE() . ',%%%'
						. 'uid_parent,'
						. \Netzmacher\QuickShop\TCA\Types::Image( $imageMode, $fal ) . ','
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.product,'
						. '  tx_quickshop_products,'
						. '--div--;LLL:EXT:quick_shop/Resources/Private/Language/tx_quickshop.xml:div.control,'
						. '  hidden,'
				),
		),
);

$image_1stforlistonly = true;
$TCA[ 'columns' ] = \Netzmacher\QuickShop\TCA\Columns::ImageColumns( $TCA[ 'columns' ], $image_1stforlistonly, $fal );
$TCA[ 'palettes' ] = \Netzmacher\QuickShop\TCA\Palettes::Image( $TCA[ 'palettes' ], $fal );

// Enable or disable the localisation
$TCA = \Netzmacher\QuickShop\TCA\Localisation::Replace( $TCA );

return $TCA;